#!/bin/sh
BINCHECK=/usr/lib/nagios/plugins/check_sap_cons

# Check_MK agent plugin for monitoring SAP instances

# Get list of all running databases
if [ $(uname -s) = Linux ]
then
    PS="ps ax -o args"
else
    PS="ps -ef -o args"
fi


if type $BINCHECK > /dev/null
then 
  echo '<<<sap_status>>>'
  SIDS=$(UNIX95=true ps ax -o args| sed -n '/^dw.sap\(...\)_D.*$/s//\1/p'|sort -u)
  if [ -z "$SIDS" ] ; then exit 0 ; fi

  for SID in $SIDS
  do
     SIDHOST=$(UNIX95=true ps ax -o args|sed -n '/^dw.sap\(...\)_D.*_\(.*\)$/s//\1\.\2/p'|sort -u|grep $SID)
     waitmax 7 $BINCHECK overview $SID|sed -e 's/SAP consistency check just finished/0/g' \
                                           -e 's/ = *\([[:digit:]]*.*\)$/ = \1/g' \
                                           -e 's/\([[:alnum:]\.]\) \([[:alnum:]%]\)/\1\.\2/g' \
                                           -e 's/^.*=$/&-1/g' \
                                           -e 's/\.$//' \
                                           -e 's/\.\([[:alnum:]%]*\)$/ \1/' \
                                           -e "s/^/${SIDHOST} /"
  done
fi
